//RTB Preferences
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Are you playing the thing?","The Thing","Thing::Playing","bool","Player_Thing",0,0,0);
	RTB_registerPref("Teamkill revenger","The Thing","Thing::tkr","bool","Player_Thing",0,0,0);
}
else
{
   $Thing::Playing = 1;
	$thing::tkr = 0;
}


datablock TSShapeConstructor(ThingDts)
{
    baseShape  = "./Thing.dts";
    //- Default Animations -
    sequence0  = "./tt_root.dsq root";
    sequence1  = "./tt_run.dsq run";
    sequence2  = "./tt_walk.dsq walk";
    sequence3  = "./tt_walk.dsq back";
    sequence4  = "./tt_walk.dsq side";
    sequence5  = "./tt_root.dsq crouch";
    sequence6  = "./tt_run.dsq crouchRun";
    sequence7  = "./tt_walk.dsq crouchBack";
    sequence8  = "./tt_walk.dsq crouchSide";
    sequence9  = "./tt_root.dsq look";
    sequence10 = "./tt_root.dsq headside";
    sequence11 = "./tt_root.dsq headUp";
    sequence12 = "./tt_jump.dsq jump";
    sequence13 = "./tt_root.dsq standjump";
    sequence14 = "./tt_root.dsq fall";
    sequence15 = "./tt_root.dsq land";
    sequence16 = "./tt_root.dsq armAttack";
    sequence17 = "./tt_root.dsq armReadyLeft";
    sequence18 = "./tt_root.dsq armReadyRight";
    sequence19 = "./tt_root.dsq armReadyBoth";
    sequence20 = "./tt_root.dsq spearready";  
    sequence21 = "./tt_root.dsq spearThrow";
    sequence22 = "./tt_root.dsq talk";  
    sequence23 = "./tt_root.dsq death1"; 
    sequence24 = "./tt_root.dsq shiftUp";
    sequence25 = "./tt_root.dsq shiftDown";
    sequence26 = "./tt_root.dsq shiftAway";
    sequence27 = "./tt_root.dsq shiftTo";
    sequence28 = "./tt_root.dsq shiftLeft";
    sequence29 = "./tt_root.dsq shiftRight";
    sequence30 = "./tt_root.dsq rotCW";
    sequence31 = "./tt_root.dsq rotCCW";
    sequence32 = "./tt_root.dsq undo";
    sequence33 = "./tt_root.dsq plant";
    sequence34 = "./tt_Sit.dsq sit";
    sequence35 = "./tt_root.dsq wrench";
    sequence36 = "./tt_root.dsq activate";
    sequence37 = "./tt_root.dsq activate2";
    sequence38 = "./tt_root.dsq leftrecoil";
    sequence39 = "./tt_bitegrab.dsq bite";
    sequence40 = "./tt_eating.dsq eating";
};

datablock AudioProfile(ThingPainSound)
{
    fileName = "./Thinghurt.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(ThingDeathSound)
{
    fileName = "./ThingDeath.wav";
    description = AudioClose3d;
    preload = true;
	 maxDistance = 100;
};  

datablock AudioProfile(ThingChangeSound)
{
    fileName = "./ThingChange.wav";
    description = AudioClose3d;
    preload = true;
};  

datablock AudioProfile(ThingGrabSound)
{
    fileName = "./ThingGrabSound.wav";
    description = AudioClose3d;
    preload = true;
};  

datablock PlayerData(ThingArmor : PlayerStandardArmor)
{
     renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./Thing.dts";
   cameraMaxDist = 5;
   cameraTilt = 0;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 0;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 65;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 1000;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 50 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 5;
   maxBackwardSpeed = 2;
   maxSideSpeed = 2;
   mindustspeed= 10;

   maxForwardCrouchSpeed = 5;
   maxBackwardCrouchSpeed = 2;
   maxSideCrouchSpeed = 2;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 1;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 1 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 5;

   minJetEnergy = 0;
    jetEnergyDrain = 0;
    canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

        boundingBox = "5 5 10.6";
        crouchBoundingBox = "5 5 10.6";

    useCustomPainEffects = true;
    PainSound            = ThingPainSound;
    DeathSound            = ThingDeathSound;

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
    
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 65;
   jumpSurfaceAngle = 66;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound            = ThingJumpSound;

   // Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
    maxItems   = 5;    //total number of bricks you can carry
    maxWeapons = 5;        //this will be controlled by mini-game code
    maxTools = 5;
    
    uiName = "Thing";
    rideable = false;
        lookUpLimit = 0.1;
        lookDownLimit = 0.1;

   numMountPoints = 1;
   mountThread[0] = "root";
   mountNode[0] = 1;

    canRide = false;
    showEnergyBar = false;
    paintable = true;
 
    brickImage = ThingBrickImage;    //the imageData to use for brick deployment
};

datablock PlayerData(PlayerNoJetT : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "Thing No-Jet Player";
	showEnergyBar = false;
};

package parasite
{
    function Armor::OnTrigger(%datablock,%player,%slot,%val)
    {
        parent::onTrigger(%datablock,%player,%slot,%val);
        if((%slot  $= 4 && %val) && (getSimTime() - %player.lastThingTry >= 10000) && (%player.isThing()))
        {
				if(%player.getDatablock().getName() !$= "thingDArmor")
				{
					schedule(100, 0, rayCastKill, %player);
				}
        }
    }
    
    function gameConnection::SpawnPlayer(%this)
    {
        parent::spawnPlayer(%this);
        if(%this.player.isThing())
        {
            %this.player.isisThing = 1;
            %this.player.changeDataBlock("PlayerNoJetT");
				%this.player.emote(ThingTransEmitterImage);
            %sound = ThingChangeSound; 
            serverplay3d(%sound,%this.player.getPosition());
        }
    }
    
    function Player::isThing(%this)
    {
        return (%this.getDataBlock().getName() $= "thingArmor" || %this.isisThing);
    }
    
    function rayCastKill(%player)
    {
        %player.playThread(0, "bitegrab");
		  %sound = ThingGrabSound;
        serverplay3d(%sound,%player.getPosition());
        %client = %player.client;
        if(isObject(%player) && %player.isThing() && %player.getDatablock().getName() !$= "thingDArmor")
        {
            %EyeVector = %client.player.getEyeVector();
            %EyePoint = %client.player.getEyePoint();
            %Range = 5;
            %RangeScale = VectorScale(%EyeVector, %Range);
            %RangeEnd = VectorAdd(%EyePoint, %RangeScale);
            %raycast = containerRayCast(%eyePoint,%RangeEnd,$TypeMasks::PlayerObjectType, %player);
        }

        if(isObject(%raycast) && !%raycast.isThing())
        {
            %player.lastThingTry = getSimTime();
            if(%player.getDataBlock().getName() !$= "thingArmor")
            {
                %sound = ThingChangeSound;
                serverplay3d(%sound,%player.getPosition());
                %player.changeDataBlock("ThingArmor");
					 %player.emote(ThingTransEmitterImage);
            }
            
            %raycast.isPDie = 1;
				%player.lpdieName = %raycast.client.name;
            schedule(1500, 0, parasiteKillThing, %player, %raycast, 5); //Animation
            schedule(500, 0, parasiteKillThing, %player, %raycast, 3); //Grabs Object
            schedule(500, 0, parasiteKillThing, %player, %raycast, 4); //Plays Right click Sound
        }
    }
    
    function parasiteKillThing(%this, %target, %val)
    {
        if(%this.isThing() && %target.isPDie)
        {
        switch(%val)
         {
            case 1:
                %target.damage(%this, %target.getWorldBoxCenter(), %target.getDatablock().maxDamage*2);
                %target.isPDie = 0;
                %target.kill();
					 %this.addHealth(100);
                messageAll('',"\c7     The thing has taken another victim...");
                
            case 2:
                %this.changeDataBlock("PlayerNoJetT");
                %sound = ThingChangeSound; 
					 %this.emote(ThingTransEmitterImage);
                serverplay3d(%sound,%this.getPosition());
                //%this.addHealth(%this.getDataBlock().maxDamage);
                
            case 3:
                %this.mountObject(%target, 1);
                %this.playThread(0, "eating");
                %this.schedule(1000, 0, playthread, 0, "root");
                %target.canDismount = 0;
                %sound = ThingGrabSound;
                serverplay3d(%sound,%this.getPosition());
					 checkWhatChangeInto(%this, %target);
                schedule(2000, 0, parasiteKillThing, %this, %target, 1);
                    
            case 4:
                %sound = ThingChangeSound;
                 serverplay3d(%sound,%this.getPosition());
                 
            case 5:
                %this.playThread(0, "bitegrab");
        }
        }
    }
	 
	 function checkWhatChangeInto(%this, %target)
	 {
	 	if(%target.getDataBlock.shapeFile !$= "base/data/shapes/player/m.dts")
		{
			%newdb = %target.getDataBlock().getName();
			schedule(8000, 0, parasiteChangeBack, %this, %newDB);
		}
		else
		{
			schedule(8000, 0, parasiteChangeBack, %this, "", %target.client);
		}
	}
    
   function parasiteChangeBack(%this, %datablock, %target)
   {
		if(%datablock !$= "")
		{
			%this.changeDataBlock(%datablock);
			%this.emote(ThingTransEmitterImage);
			%sound = ThingChangeSound;
			serverplay3d(%sound,%this.getPosition());
			//%healthy = %this.getDatablock().maxDamage / -2;
			//%this.addHealth(%healthy);
			//%this.addHealth(%this.getDataBlock().maxDamage);
		}
		else
		{
			if(isObject(%this))
			{
				%this.changeDataBlock("PlayerNoJetT");
				%this.emote(ThingTransEmitterImage);
				%sound = ThingChangeSound;
				serverplay3d(%sound,%this.getPosition());
				//%healthy = %this.getDatablock().maxDamage / -2;
				//%this.addHealth(%healthy);
				//%this.addHealth(%this.getDataBlock().maxDamage);
				%this.client.replicateAvatar(%target);
			}
		}
   }
    
    
    function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
    {
        parent::damage(%this,%obj,%sourceObject,%position,%damage,%damageType);
        if(%obj.isThing())
        {
            %health = %obj.getDatablock().maxDamage - %obj.getDamageLevel();
            %percentage = %health / %obj.getDataBlock().maxDamage;
            %percentage = %percentage * 100;
            if(%percentage <= 50 && %obj.getDatablock().getName() !$= "ThingDArmor" || %obj.getDatablock().getName() !$= "ThingArmor")
            {
                %sound = ThingChangeSound;
                serverplay3d(%sound,%obj.getPosition());
                %obj.changeDataBlock("ThingDArmor");
					 %obj.emote(ThingTransEmitterImage);
					 //%healthy = %obj.getDatablock().maxDamage / -2;
					 //%obj.addHealth(%healthy);
                //%obj.addHealth(%obj.getDataBlock().maxDamage);
					 %obj.lastDamageTime = getSimTime();
					 schedule(8000, 0, checkLastDamageTime, %obj);
            }
        }
    }
	 
	function checkLastDamageTime(%player)
	{
		if(isObject(%player) && getSimTime() - %player.lastDamageTime >= 15000)
		{
			%sound = ThingChangeSound;
         serverplay3d(%sound,%player.getPosition());
			//%healthy = %player.getDatablock().maxDamage / -2;
			//%player.addHealth(%healthy);
			%player.changeDatablock("ThingArmor");
			%player.emote(ThingTransEmitterImage);
			//%player.addHealth(%player.getDataBlock().maxDamage);
		}
	}
	 
	function serverCmdLight(%this)
    {
		%player = %this.player;
		if(!isObject(%player))
		{
			parent::serverCmdLight(%this);
			return;
		}
		if(%player.isThing())
		{
			parasiteBlind(%player);
			return;
		}
		parent::serverCmdLight(%this);
	}
	
	function parasiteBlind(%this)
	{
		if(getsimTime() - %this.lastWOTime >= 70000)
		{
			messageAll('',"\c7     The thing has blinded everyone near him!");
			%this.lastWOTime = getSimTime();
			%pos = %this.getPosition();
			%box = "50 50 50";
			InitContainerRadiusSearch(%pos,%box,$TypeMasks::PlayerObjectType);
			while(%next = containerSearchNext())
			{
				if(%next != %this && isObject(%next))
				{
					for(%i = 0; %i < $Thing_WhiteOutNum; %i++)
					{
						schedule(150 * %i, 0, pblindPeople, %next);
					}
				}
			}
		}
		else
		{
			messageClient(%this.client,'',"\c4---\c6Blinding is still on cooldown!");
		}
	}

	function pblindPeople(%person)
	{
		%person.setWhiteOut(1);
	}
	
	function gameConnection::onDeath(%client, %killerPlayer, %killerClient, %damageType, %damageLoc)
	{
		%a = $Thing::Tkr;
		if(%a && !%killerPlayer.isThing())
		{
			%killerPlayer.kill();
			messageAll('',"\c7     \c3" @ %killerClient.name @ "\c7 was killed for killing \c3" @ %client.name @ "\c7.");
		}
		parent::onDeath(%client, %killerPlayer, %killerClient, %damageType, %damageLoc);
	}
	
	function gameConnection::ReplicateAvatar(%cl, %client)
	{
		%this = %cl.player;
		%client = findClientByName(%this.lpdiename);
		%this.hideNode("ALL"); //Hide all nodes, to uncover later
		if(%client.hat)
		{
			%this.unHideNode($hat[%client.hat]);
			%this.setNodeColor($hat[%client.hat], %client.hatColor);
			if(%client.accent)
			{
				%this.unHideNode($accent[%client.accent]);
				%this.setNodeColor($accent[%client.accent], %client.accentColor);
			}
		}
		%this.unHideNode("headskin");
		%this.setNodeColor("headSkin", %client.headcolor);
		%this.unHideNode($chest[%client.chest]);
		%this.setNodeColor($chest[%client.chest], %client.chestColor);
		if(%client.secondPack)
		{
			%this.unHideNode($secondPack[%client.secondPack]);
			%this.setNodeColor($secondPack[%client.secondPack], %client.secondPackColor);
		}
		if(%client.pack)
		{
			%this.unHideNode($pack[%client.pack]);
			%this.setNodeColor($pack[%client.pack], %client.packColor);
		}
		%this.unHideNode($larm[%client.larm]);
		%this.setNodeColor($larm[%client.larm], %client.larmColor);
		%this.unHideNode($rarm[%client.rarm]);
		%this.setNodeColor($rarm[%client.rarm], %client.rarmColor);
		%this.unHideNode($lhand[%client.lhand]);
		%this.setNodeColor($lhand[%client.lhand], %client.lhandColor);
		%this.unHideNode($rhand[%client.rhand]);
		%this.setNodeColor($rhand[%client.rhand], %client.rhandColor);
		%this.unHideNode($hip[%client.hip]);
		%this.setNodeColor($hip[%client.hip], %client.hipcolor);
		if(%client.hip == 0)
		{
			%this.unHideNode($rleg[%client.rleg]);
			%this.setNodeColor($rleg[%client.rleg], %client.rlegColor);
			%this.unHideNode($lleg[%client.lleg]);
			%this.setNodeColor($lleg[%client.lleg], %client.llegColor);
		}
		else
		{
			%this.unHideNode("SkirtTrimLeft");
			%this.setNodeColor("SkirtTrimLeft", %client.llegColor);	
			%this.unHideNode("SkirtTrimRight");
			%this.setNodeColor("SkirtTrimRight", %client.rlegColor);
		}
		%this.setDecalName(%client.decalName);
		%this.setFaceName(%client.faceName);
	}
};
activatePackage(parasite);
$Thing_WhiteOutNum = 15;

//Damaged State for Thing
datablock TSShapeConstructor(ThingDDts)
{
    baseShape  = "./ThingD.dts";
    //- Default Animations -
    sequence0  = "./ttD_root.dsq root";
    sequence1  = "./ttD_run.dsq run";
    sequence2  = "./ttd_run.dsq walk";
    sequence3  = "./ttd_run.dsq back";
    sequence4  = "./ttd_run.dsq side";
    sequence5  = "./ttD_root.dsq crouch";
    sequence6  = "./ttD_run.dsq crouchRun";
    sequence7  = "./ttd_run.dsq crouchBack";
    sequence8  = "./ttd_run.dsq crouchSide";
    sequence9  = "./ttD_root.dsq look";
    sequence10 = "./ttD_root.dsq headside";
    sequence11 = "./ttD_root.dsq headUp";
    sequence12 = "./ttD_root.dsq jump";
    sequence13 = "./ttD_root.dsq standjump";
    sequence14 = "./ttD_root.dsq fall";
    sequence15 = "./ttD_root.dsq land";
    sequence16 = "./ttD_root.dsq armAttack";
    sequence17 = "./ttD_root.dsq armReadyLeft";
    sequence18 = "./ttD_root.dsq armReadyRight";
    sequence19 = "./ttD_root.dsq armReadyBoth";
    sequence20 = "./ttD_root.dsq spearready";  
    sequence21 = "./ttD_root.dsq spearThrow";
    sequence22 = "./ttD_root.dsq talk";  
    sequence23 = "./ttD_root.dsq death1"; 
    sequence24 = "./ttD_root.dsq shiftUp";
    sequence25 = "./ttD_root.dsq shiftDown";
    sequence26 = "./ttD_root.dsq shiftAway";
    sequence27 = "./ttD_root.dsq shiftTo";
    sequence28 = "./ttD_root.dsq shiftLeft";
    sequence29 = "./ttD_root.dsq shiftRight";
    sequence30 = "./ttD_root.dsq rotCW";
    sequence31 = "./ttD_root.dsq rotCCW";
    sequence32 = "./ttD_root.dsq undo";
    sequence33 = "./ttD_root.dsq plant";
    sequence34 = "./ttD_root.dsq sit";
    sequence35 = "./ttD_root.dsq wrench";
    sequence36 = "./ttD_root.dsq activate";
    sequence37 = "./ttD_root.dsq activate2";
    sequence38 = "./ttD_root.dsq leftrecoil";
};

datablock PlayerData(ThingDArmor : PlayerStandardArmor)
{
     renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./ThingD.dts";
   cameraMaxDist = 3;
   cameraTilt = 0;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 0;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 65;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 200;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 50 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 7;
   maxBackwardSpeed = 5;
   maxSideSpeed = 2;
   mindustspeed= 10;

   maxForwardCrouchSpeed = 7;
   maxBackwardCrouchSpeed = 5;
   maxSideCrouchSpeed = 2;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 1;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 1 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 5;

   minJetEnergy = 0;
    jetEnergyDrain = 0;
    canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

        boundingBox = "5 5 3";
        crouchBoundingBox = "5 5 3";

    useCustomPainEffects = true;
    PainSound            = ThingPainSound;
    DeathSound            = ThingDeathSound;

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
    
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 65;
   jumpSurfaceAngle = 66;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound            = ThingJumpSound;

   // Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
    maxItems   = 5;    //total number of bricks you can carry
    maxWeapons = 5;        //this will be controlled by mini-game code
    maxTools = 5;
    
    uiName = "Thing Damaged";
    rideable = false;
        lookUpLimit = 0.1;
        lookDownLimit = 0.1;

   numMountPoints = 1;
   mountThread[0] = "root";
   mountNode[0] = 1;

    canRide = false;
    showEnergyBar = false;
    paintable = true;
 
    brickImage = ThingBrickImage;    //the imageData to use for brick deployment
};



